#include <iostream>
#include <cmath>
using namespace std;

int main() {
    // Declare variables and assign values from user input
    double a, b, c;
    cout << "Please enter the value of a: ";
    cin >> a;
    cout << "Please enter the value of b: ";
    cin >> b;
    cout << "Please enter the value of c: ";
    cin >> c;

    // Calculate the discriminant of the quadratic equation
    double discriminant = b * b - 4 * a * c;

    // Determine various conditions to check the nature of the solutions
    int infinite_solutions = (a==0 && b == 0 && c == 0); // y=0x^2+0x+0
    int no_solution = (a==0 && b == 0 && c != 0); // y=0x^2+0x+c
    int has_one_linear_solution = (a==0 && b != 0); // The equation becomes linear and has one single solution. y=0x+bx+c
    int no_real_solution = (a != 0 && discriminant < 0.0);
    int has_two_real_solutions = (a != 0 && discriminant > 0.0);
    int has_one_real_solution = (a != 0 && discriminant == 0.0);

    // Use bitwise OR and shift operations to combine different conditions into a single value for the switch statement
    switch (infinite_solutions << 5 | no_solution << 4 | has_one_linear_solution << 3 | no_real_solution << 2 | has_two_real_solutions << 1 | has_one_real_solution){
        case 0b100000:
            cout << "The equation has infinite number of solutions." << endl;
            break;
        case 0b10000:
            cout << "The equation has no solution." << endl;
            break;
        case 0b1000:
            cout << "The equation becomes linear and has one solution, and x=" << -c/b << endl;
            break;
        case 0b100:
            cout << "The equation has no real solutions." << endl;
            break;
        case 0b10:
            cout << "The equation has two real solutions x1=" << (-b + sqrt(discriminant)) / (2 * a)
                 << " and x2=" << (-b - sqrt(discriminant)) / (2 * a) << endl;
            break;
        case 0b1:
            cout << "This equation has a single real solution x=" << -b / (2 * a) << endl;
            break;
    }

    return 0;
}
