#include <iostream>
using namespace std;

const int FLOOR_ROUND = 1;
const int CEILING_ROUND = 2;
const int ROUND = 3;

int main () {
    // Declare variables to store user input
    double num;
    int rounding_method;

    // Get values of variables from user input
    cout << "Please enter a Real number:" << endl;
    cin >> num;
    cout << "Choose your rounding method:\n"
         << "1.Floor round\n"
         << "2.Ceiling round\n"
         << "3.Round to the nearest whole number\n";
    cin >> rounding_method;


    // Check if the entered number is an integer
    int is_integer = (num == (int) num);

    // Check if the entered number is negative
    int is_negative = (num < 0);

    if (rounding_method == FLOOR_ROUND || rounding_method == CEILING_ROUND || rounding_method == ROUND) {
        // Use bitwise OR and shift operations to combine different conditions into a single value for the switch statement
        switch (is_integer << 1 | is_negative) {
            case 0b10:
            case 0b11:
                cout << (int)num << endl; // If the number is an integer, just display it without any rounding
                break;
            case 0b0:  // If the number is not an integer and is positive
                switch (rounding_method) {
                    case FLOOR_ROUND:
                        cout << (int)num << endl;
                        break;
                    case CEILING_ROUND:
                        cout << (int)(num+1) << endl;
                        break;
                    case ROUND:
                        cout << (int)(num+0.5) << endl;
                        break;
                }
                break;
            case 0b1:  // If the number is not an integer and is negative
                switch (rounding_method) {
                    case FLOOR_ROUND:
                        cout << -1 * ((int)(-num+1)) << endl;
                        break;
                    case CEILING_ROUND:
                        cout << -1 * ((int)(-num)) << endl;
                        break;
                    case ROUND:
                        cout << -1 * ((int)(-num+0.5)) << endl;
                        break;
                }
                break;
        }
    } else {
        cout << "Invalid rounding method.\n";
    }

    return 0;
}